ZZ-ERROR-HANDLER.
    IF ERR-SUCCESS THEN GO TO ZZ-ERROR-HANDLER-EXIT.
    MOVE ZZ-ERRFILE TO ZZ-BUFFER.
    COMPUTE ZZ-POS = STORED-CHAR-LENGTH(ZZ-BUFFER) + 1.
    MOVE "(" TO ZZ-BUFFER(ZZ-POS:).
    COMPUTE ZZ-POS = STORED-CHAR-LENGTH(ZZ-BUFFER) + 1.
    MOVE ZZ-ERROR TO ZZ-BUFFER(ZZ-POS:).
    COMPUTE ZZ-POS = STORED-CHAR-LENGTH(ZZ-BUFFER) + 1.
    MOVE "):" TO ZZ-BUFFER(ZZ-POS:).
    COMPUTE ZZ-POS = STORED-CHAR-LENGTH(ZZ-BUFFER) + 2.
    MOVE "unknown error" TO ZZ-ERRMESSAGE.
    IF ERR-DUP-KEY-WRITTEN THEN
       MOVE "duplicate key written" TO ZZ-ERRMESSAGE.
    IF ERR-OPT-FILE-NOTFOUND THEN
       MOVE "optional file not found" TO ZZ-ERRMESSAGE.
    IF ERR-NO-UNIT THEN
       MOVE "no (optional) unit" TO ZZ-ERRMESSAGE.
    IF ERR-EOF THEN
       MOVE "end of file found" TO ZZ-ERRMESSAGE.
    IF ERR-OUT-OF-KEY THEN
       MOVE "out of key" TO ZZ-ERRMESSAGE.
    IF ERR-KEY-INVALID THEN
       MOVE "key invalid" TO ZZ-ERRMESSAGE.
    IF ERR-ATTEMPT-DUP-KEY THEN
       MOVE "attempt to write duplicate key" TO ZZ-ERRMESSAGE.
    IF ERR-KEY-NOT-FOUND THEN
       MOVE "key not found" TO ZZ-ERRMESSAGE.
    IF ERR-PERMANENT-IO THEN
       MOVE "permanent i-o error" TO ZZ-ERRMESSAGE.
    IF ERR-INCONSISTENT-FN THEN
       MOVE "inconsistend function" TO ZZ-ERRMESSAGE.
    IF ERR-BOUNDARY-VIOLATION THEN
       MOVE "boundary violation" TO ZZ-ERRMESSAGE.
    IF ERR-FILE-NOTFOUND THEN
       MOVE "physical file not found" TO ZZ-ERRMESSAGE.
    IF ERR-PERMISSION-DENIED THEN
       MOVE "permission denied" TO ZZ-ERRMESSAGE.
    IF ERR-CLOSED-WITH-LOCK THEN
       MOVE "closed file with lock" TO ZZ-ERRMESSAGE.
    IF ERR-CONFLICT-ATTRIBUTE THEN
       MOVE "conflicting attribute(s)" TO ZZ-ERRMESSAGE.
    IF ERR-FILE-ALLREADY-OPEN THEN
       MOVE "file is allready open" TO ZZ-ERRMESSAGE.
    IF ERR-FILE-NOT-OPEN THEN
       MOVE "file is not open" TO ZZ-ERRMESSAGE.
    IF ERR-READ-NOT-DONE THEN
       MOVE "read not done" TO ZZ-ERRMESSAGE.
    IF ERR-RECORD-OVERFLOW THEN
       MOVE "record overflow" TO ZZ-ERRMESSAGE.
    IF ERR-READ-ERROR THEN
       MOVE "read error" TO ZZ-ERRMESSAGE.
    IF ERR-OPEN-INPUT-DENIED THEN
       MOVE "open input denied" TO ZZ-ERRMESSAGE.
    IF ERR-OPEN-OUTPUT-DENIED THEN
       MOVE "open output denied" TO ZZ-ERRMESSAGE.
    IF ERR-OPEN-IO-DENIED THEN
       MOVE "open i-o denied" TO ZZ-ERRMESSAGE.
    IF ERR-RECORD-LOCKED THEN
       MOVE "record locked" TO ZZ-ERRMESSAGE.
    IF ERR-END-OF-PAGE THEN
       MOVE "end of page" TO ZZ-ERRMESSAGE.
    IF ERR-LINAGE-SPEC-INVALID THEN
       MOVE "linage specification is invalid" TO ZZ-ERRMESSAGE.
    IF ERR-FILESHARING-FAILED THEN
       MOVE "filesharing failed" TO ZZ-ERRMESSAGE.
    IF ERR-FILE-NOT-AVAILABLE THEN
       MOVE "file not available" TO ZZ-ERRMESSAGE.
    MOVE ZZ-ERRMESSAGE TO ZZ-BUFFER(ZZ-POS:).
ZZ-ERROR-HANDLER-XXX.
    DISPLAY ZZ-BUFFER UPON SYSERR.
    GOBACK.
ZZ-ERROR-HANDLER-EXIT.
