      *>----------------------------------------------------+
      *> COPYRIGHT(2017,2018) BY VEIT HEISE, PQM-CONSULTING |
      *> ALL RIGHTS RESERVED BY THE AUTHOR                  |
      *> THIS IS RECOMMENDED FOR THE USAGE OF THIS SOFTWARE |
      *> INSIDE COMMERCIAL PRODUCT. USING FOR COMMERCIAL    |
      *> PRODUCTS WITHOUT PERMISSION BY THE AUTHOR IS       |
      *> LEGALLY PROHIBITTED.                               |
      *>----------------------------------------------------+
      >>SOURCE FORMAT FIXED
       IDENTIFICATION DIVISION.
       PROGRAM-ID. TEMPLATE.
      *>---------------------------------------------------------------+
      *> P R O G R A M - N A M E                                       |
      *>---------------------------------------------------------------+
      *> B301  -  INIT: STANDARD-HEADER                                |
      *>---------------------------------------------------------------+
      *>---------------------------------------------------------------+
      *> B900  -  STANDARD-ERROR HANDLER                               |
      *>---------------------------------------------------------------+
       ENVIRONMENT DIVISION.
       CONFIGURATION SECTION.
       SOURCE-COMPUTER.    HP-PRO-BOOK-650G.
       OBJECT-COMPUTER.    UBUNTU-64-BIT.
       SPECIAL-NAMES.
          CURSOR IS COB-CURSOR,
          CRT STATUS IS COB-CRT-STATUS,
          DECIMAL-POINT IS COMMA.
       REPOSITORY.
          FUNCTION ALL INTRINSIC.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
          COPY "sd-files".
       I-O-CONTROL.
       DATA DIVISION.
       FILE SECTION.
          COPY "fd-files".
       WORKING-STORAGE SECTION.
      *>---------------------------------------------------------------+
      *>---------------------------------------------------------------+
      *>---------------------------------------------------------------+
          COPY "st-files".
      *>---------------------------------------------------------------+
          COPY "dat-global".
       SCREEN SECTION.
      *>---------------------------------------------------------------+
      *> SCREEN SCREEN-03 (ARTIKEL/LEISTUNGEN - LISTE)                 |
      *>---------------------------------------------------------------+
      *>---------------------------------------------------------------+
      *> SCREEN HEADER                                                 |
      *>---------------------------------------------------------------+
       01 SCREEN-HEADER.
          COPY "scr-standard-header".
      *>---------------------------------------------------------------+
      *> SCREEN STANDARD-ERROR                                         |
      *>---------------------------------------------------------------+
          COPY "xerror".
      *>
       PROCEDURE DIVISION.
       DECLARATIVES.
       END DECLARATIVES.
      *>---------------------------------------------------------------+
      *> P R O G R A M M   S T A R T E T   H I E R                     |
      *>---------------------------------------------------------------+
       PROGRAM-START.
          GOBACK.
      *>---------------------------------------------------------------+
      *> B301  -  INIT: STANDARD-HEADER                                |
      *>---------------------------------------------------------------+
       B301.
         MOVE CURRENT-DATE TO DATUM-AKTUELL.
         ACCEPT ZZ-REFE1 FROM COLUMNS.
         SUBTRACT 18 FROM ZZ-REFE1 GIVING ZZ-START-DATE.
         ACCEPT ZZ-REFE1 FROM COLUMNS.
         COMPUTE ZZ-REFE2 = STORED-CHAR-LENGTH(ZZ-HEADER) / 2.
         COMPUTE ZZ-REFE1 = ZZ-REFE1 / 2.
         COMPUTE ZZ-START-HEADER = ZZ-REFE1 - ZZ-REFE2 + 1.
       B301-EXIT.
      *>
       END PROGRAM TEMPLATE.
      *>
      *> DO NOT ADD CODE HERE!
      *>
